
SET SERVEROUTPUT ON SIZE 1000000
--SET ECHO ON
SET TIMING ON TIME ON
SET SCAN ON

column spool_file new_value n_spool_file noprint;
SELECT 'uninst_vercomp.'||to_char(sysdate,'YYYYMMDD')||'.log'  spool_file FROM dual;
SPOOL &n_spool_file

SHOW USER

var rc number
exec :rc := 1;

WHENEVER SQLERROR EXIT 5 rollback;

DECLARE



TYPE compverType IS TABLE OF component_version%ROWTYPE INDEX BY BINARY_INTEGER;
del_compver    compverType;

type refcur is ref cursor;
cur_component_ver refcur;

v_release_str  varchar(30):='&1';
v_build_str    varchar(3) :='&2';
v_rowcnt       integer := 0;   
v_rowcount     integer := 0;
v_max_comp_ver component_version.component_version_id%type;

v_inst_comp_ver   component_installed.component_version_id%type;
v_inst_comp_type  component_installed.install_type%type;
v_inst_comp_date  component_installed.install_date%type;

v_success      boolean := false;

BEGIN

   --DBMS_OUTPUT.PUT_LINE ('Script Started: ' || to_char (SYSDATE, 'dd mon yyyy hh:mi:ss'));
   --DBMS_OUTPUT.PUT_LINE ('release str   : ' || v_release_str || ', build_str : ' || v_build_str );
   
   select max(component_version_id) into v_max_comp_ver from component_version where revision = v_release_str
   and build_number = v_build_str;

   FOR cur_component_ver IN ( SELECT component_version_id, component_id FROM component_version 
                              where revision = v_release_str 
                              and build_number = v_build_str
                              order by component_version_id desc ) 
   LOOP
      BEGIN
         --DBMS_OUTPUT.PUT_LINE ('versionid :' || cur_component_ver.component_version_id || ' maxvver   :' || v_max_comp_ver);

         if (v_max_comp_ver = cur_component_ver.component_version_id) then
            --DBMS_OUTPUT.PUT_LINE ('del component_history , component_installed, component_installing...');
            delete component_history where component_version_id = v_max_comp_ver;
            delete component_installed where component_version_id = v_max_comp_ver;
            delete component_installing where component_version_id = v_max_comp_ver;

            v_rowcnt := v_rowcnt + 1;
            select * into del_compver(v_rowcnt) from component_version where component_version_id = v_max_comp_ver;
            v_max_comp_ver := v_max_comp_ver - 1;
            
	 end if;
      end;
   end loop;

   for i in 1 .. del_compver.count
   loop
      --DBMS_OUTPUT.PUT_LINE ('del component_version, versionid :' || del_compver(i).component_version_id || 
      --                      ' , compid: ' || del_compver(i).component_id );
      
      delete component_version where component_version_id = del_compver(i).component_version_id;

      --DBMS_OUTPUT.PUT_LINE ('deleted component_version');
      BEGIN

      select component_version_id into v_inst_comp_ver from component_version where component_id = del_compver(i).component_id and 
      component_version_id = (select max(component_version_id) from component_version where component_id = del_compver(i).component_id);

      EXCEPTION
      WHEN NO_DATA_FOUND THEN NULL;
      END;

      IF (SQL%ROWCOUNT > 0 ) THEN

	 --DBMS_OUTPUT.PUT_LINE ('COMPONENT_HISTORY...v_inst_comp_ver:' || v_inst_comp_ver);
         select install_type, action_date into v_inst_comp_type, v_inst_comp_date
         from COMPONENT_HISTORY  
         where component_version_id = v_inst_comp_ver and install_action like 'FINISH%' 
         and component_hist_id = (select max(component_hist_id) from COMPONENT_HISTORY 
                                 where component_version_id = v_inst_comp_ver and install_action like 'FINISH%');

         select count(*) into v_rowcount from component_installed 
         where component_version_id =  v_inst_comp_ver
         and   install_type         =  v_inst_comp_type;

         if  (v_rowcount = 0) then
       

         --DBMS_OUTPUT.PUT_LINE ('add component_installed compver:' || v_inst_comp_ver || ' type :' || v_inst_comp_type || ' date : ' || to_char (v_inst_comp_date, 'dd mon yyyy hh:mi:ss') );

         insert into component_installed (component_version_id,install_type,install_date) 
         values (v_inst_comp_ver, v_inst_comp_type, v_inst_comp_date);

         else 
            DBMS_OUTPUT.PUT_LINE ('existing component_installed compver:' || v_inst_comp_ver || ' type :' || v_inst_comp_type || ' date : ' || to_char (v_inst_comp_date, 'dd mon yyyy hh:mi:ss') );

         end if;  

         v_success := true;
      -- 20090612:nothing was found for this component_version
      else
         v_success := true;
      --- end of 20090612
      end if;


   end loop;

   --DBMS_OUTPUT.PUT_LINE ('Script Ended  : ' || to_char (SYSDATE, 'dd mon yyyy hh:mi:ss'));
   
   if (v_success = true) then
      select 0 into :rc  from dual;
      if ( 'commit' = '&3') then
         --DBMS_OUTPUT.PUT_LINE ('commit now!');
         commit; 
      else
         --DBMS_OUTPUT.PUT_LINE ('preview only!');
         rollback;
      end if;
   else
      --DBMS_OUTPUT.PUT_LINE ('unsucess, rollback!');
      rollback;
   end if;
 

END;
/

SHOW ERRORS

SET TIMING OFF TIME OFF
SET ECHO OFF
SPOOL OFF

exit :rc
